//+------------------------------------------------------------------+
//|                                                         Spud.mq4 |
//|                               Copyright  2007, Mulyadi Santoso. |
//|                                                musanto@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Mulyadi Santoso."
#property link      "musanto@yahoo.com"

#property indicator_separate_window
#property indicator_buffers   1
#property indicator_color1    Lime
#property indicator_maximum   100
#property indicator_minimum   0
#property indicator_level1    20
#property indicator_level2    50
#property indicator_level3    80


// Constant -------------------------------------------------------
#define  MaxSlowing        10
#define  MaxMarkHL 50

// Gen.Var --------------------------------------------------------
int      diff,diff1;
int      BarS;
bool     loop = true;

//---- input parameters
extern   int         Per      = 15;


int       Pk = 5;
int       Pd = 3;
int       Ps = 3;

//---- buffers
double SBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorShortName("Spud Stoch("+DoubleToStr(Per,0)+")");
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,SBuffer);
   SetIndexLabel(0,"Stoch ("+DoubleToStr(Per,0)+")");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted(),i,j,k,m;
   double    sumlo,sumhi,loes,hies,MafB,MasB;
   int limit = 3000;//Bars - counted_bars;//MaxBar-counted_bars;//
  
//----
   if (Ps<1) Ps = 1;
   for (i=limit;i>=0;i--)
   {  
      sumlo = 0.0;sumhi=0.0;
      m = SeekBar1(i,Per); 
      for (k=i;k<i+Ps;k++) 
      {  
         hies = iHigh(NULL,PERIOD_M1,iHighest(NULL,PERIOD_M1,MODE_HIGH,diff,m));
         loes = iLow(NULL,PERIOD_M1,iLowest(NULL,PERIOD_M1,MODE_LOW,diff,m));
         sumlo+= iClose(NULL,PERIOD_M1,m)-loes ; 
         sumhi+= hies - loes;
         m+= diff1;
         if (k<i+Ps-1) m = SeekBar2(m,Per);
      }
      if (sumhi==0.0)
         SBuffer[i]   = 100;
      else
         SBuffer[i]   = sumlo / sumhi * 100;
         
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
int SeekBar1(int i,int per)
{  int   j;
   datetime wkt1= iTime(NULL,0,i)+(Period()-1)*60,wkt2,wkt3;
   diff=0;diff1 = 0;j = 0;
   if (iTime(NULL,PERIOD_M1,0)<wkt1)
   {
      wkt2 = iTime(NULL,PERIOD_M1,0)-(per*Pk)*60;
      diff= iBarShift(NULL,PERIOD_M1,wkt2);
      wkt3 = iTime(NULL,PERIOD_M1,0)-(per)*60;
      diff1= iBarShift(NULL,PERIOD_M1,wkt3);
   }
   else
   {
      j = iBarShift(NULL,PERIOD_M1,wkt1);
      wkt2 = iTime(NULL,PERIOD_M1,j)-(per*Pk)*60;
      diff = iBarShift(NULL,PERIOD_M1,wkt2);
      diff = diff - j; 
      wkt3 = iTime(NULL,PERIOD_M1,j)-(per)*60;
      diff1= iBarShift(NULL,PERIOD_M1,wkt3);
      diff1 = diff1 - j; 
      
   } 
   //Print(" w1 ",TimeToStr(wkt1,TIME_MINUTES),
   //      " w2 ",TimeToStr(wkt2,TIME_MINUTES),
   //      " w3 ",TimeToStr(wkt3,TIME_MINUTES),
   //      " j  ",j,
   //      " diff ",diff,
   //      " dif1 ",diff1);
   return(j);
}
int SeekBar2(int i,int per)
{  
   int   j;
   datetime wkt1,wkt2,wkt3;
   
   diff=0;diff1 = 0;j = 0;
   
   wkt1= iTime(NULL,PERIOD_M1,i);
   j = iBarShift(NULL,PERIOD_M1,wkt1);
   
   wkt2 = iTime(NULL,PERIOD_M1,j)-(per*Pk)*60;
   diff = iBarShift(NULL,PERIOD_M1,wkt2);
   diff = diff - j; 
   wkt3 = iTime(NULL,PERIOD_M1,j)-(per)*60;
   diff1= iBarShift(NULL,PERIOD_M1,wkt3);
   diff1 = diff1 - j; 
   
   //Print("*w1 ",TimeToStr(wkt1,TIME_MINUTES),
   //      " w2 ",TimeToStr(wkt2,TIME_MINUTES),
   //      " w3 ",TimeToStr(wkt3,TIME_MINUTES),
   //      " j  ",j,
   //      " diff ",diff,
   //      " dif1 ",diff1);
   return(j);
}

